/* 01-Mai-2007
   Copyright: H.Helmke, F. Hoeppner
   siehe Buch: Kapitel 4, 8
   Netzplanung mit Zeiger-Semantik
   C++-Version von Vorgang
*/

#include "Vorgang.h"

#include <iostream> // wg. Bildschirmausgabe 
using namespace std;

/** fruehester Anfang und spaetestes Ende
des Vorgangs werden mit 0 belegt. */
Vorgang::Vorgang() : vorgaenger(), nachfolger() {
   fruehanf = 0;
   spaetend = 0;
   dauer = 0;
}

/** Der Speicherplatz, den nachfolger und
vorgaenger belegen, wird freigegeben*/
Vorgang::~Vorgang() {
}

void Vorgang::setDauer(double d) {
   dauer = d;
   }
double Vorgang::getFruehanf() const {
   return fruehanf;
   }
double Vorgang::getSpaetend() const {
   return spaetend;
   }



/** true, wenn Vorgang durchfuehrbar ist */
bool Vorgang::istDurchfuehrbar() const {
   return fruehanf + dauer > spaetend;
}

/** Wenn fruehesten Endzeitpunkt vom Vorgang vv
grer als bisheriger frhester Anfang
von Vorgang this, wird letzerer angepasst. */
void Vorgang::passeFruehanfAn(const Vorgang* vv){
   double fe = vv->fruehanf + vv->dauer;
   if (fe > fruehanf) {
      fruehanf = fe;
}}


/** Wenn spaetester Anf-Zeitpunkt von Vorgang vn
kleiner als bisheriges spaetestes Ende von 
Vorgang this, wird letzteres angepasst.*/
void Vorgang::passeSpaetEndAn(const Vorgang* vn){
   double sa = vn->spaetend - vn->dauer;
   if (spaetend > sa) { 
       spaetend = sa;
}}


/* Vorgang v wird auf Bildschirm ausgegeben.*/
void Vorgang::ausgabeVorgang()const {
   cout << fruehanf << ", " 
      << fruehanf + dauer
      << "], [SA, SE]: [" 
      << spaetend - dauer << ", "
      << spaetend << "]" << endl;
}

/** Vorgang this wird als Vorgaenger beim
Vorgang vn eingetragen und umgekehrt. 
Wenn der Speicherplatz noch nicht ausreicht,
wird entsprechend mehr angefordert. */
void Vorgang::setzeNachf(Vorgang* vn) {
   vorgaenger.fuegeHinzu(vn);
   vn->nachfolger.fuegeHinzu(this);
}
/** Ist der Vorgang this ein Vorgaenger 
von *vn, d.h. kommt vn im Array der 
Nachfolger von this vor?                     */
bool Vorgang::istVorgaengerVon
   (const Vorgang* vn) const {
   return vorgaenger.istElem(vn);
}


